clear;
close all;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Exercise 3a:

f = double(imread('coins.png'));

figure;

subplot(1,3,1);
imshow(uint8(f));

subplot(1,3,2);
imshow(dx(f),[]);

subplot(1,3,3);
imshow(dy(f),[]);

function d = dx(f)
    [h,w] = size(f);
    d = zeros(h,w);
    for y = 1:h
        for x = 1:w-1
            d(y,x) = f(y,x+1) - f(y,x);
        end
    end
end

function d = dy(f)
    [h,w] = size(f);
    d = zeros(h,w);
    for x = 1:w
        for y = 1:h-1
            d(y,x) = f(y+1,x) - f(y,x);
        end
    end
end